Wt: Wt::WFileDropWidget Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Classes | Public Member Functions | Protected Member Functions | List of all members
Wt::WFileDropWidget Class Reference

A widget that allows dropping files for upload. More...

`#include <Wt/WFileDropWidget.h>`

Inheritance diagram for Wt::WFileDropWidget:
[legend]

## Classes
class | File
| A nested class of WFileDropWidget representing a file. More...

## Public Member Functions
| WFileDropWidget ()
| Constructor.
| ~WFileDropWidget ()
| Destructor.
std::vector< File * > | uploads () const
| Returns the vector of uploads managed by this widget.
int | currentIndex () const
| Return the index of the file that is currently being handled.
void | cancelUpload (File *file)
| Cancels the upload of a file.
bool | remove (File *file)
| Removes the file.
void | setAcceptDrops (bool enable)
| When set to false, the widget no longer accepts any files.
void | setHoverStyleClass (const std::string &className)
| Set the style class that is applied when a file is hovered over the widget.
void | setFilters (const std::string &acceptAttributes)
| Sets input accept attributes.
void | setDropIndicationEnabled (bool enable)
| Highlight widget if a file is dragged anywhere on the page.
bool | dropIndicationEnabled () const
| Returns if the widget is highlighted for drags anywhere on the page.
void | setGlobalDropEnabled (bool enable)
| Allow dropping the files anywhere on the page.
bool | globalDropEnabled () const
| Returns if all drops are forwarded to this widget.
void | setJavaScriptFilter (const std::string &filterFn, ::uint64_t chunksize=0, const std::vector< std::string > &imports=std::vector< std::string >())
| Supply a function to process file data before it is uploaded to the server.
Signal< std::vector< File * > > & | drop ()
| The signal triggers if one or more files are dropped.
Signal< File * > & | newUpload ()
| The signal triggers when the upload of a file is about to begin.
Signal< File * > & | uploaded ()
| The signal is triggered if any file finished uploading.
Signal< File *, ::uint64_t > & | tooLarge ()
| The signal triggers when a file is too large for upload.
Signal< File * > & | uploadFailed ()
| The signal triggers when an upload failed.
Public Member Functions inherited from Wt::WContainerWidget
| WContainerWidget ()
| Creates a container.
| ~WContainerWidget ()
| Destructor.
void | setLayout (std::unique_ptr< WLayout > layout)
| Sets a layout manager for the container.
template<typename Layout >
Layout * | setLayout (std::unique_ptr< Layout > layout)
| Sets a layout manager for the container, returning a raw pointer.
WLayout * | layout () const
| Returns the layout manager that was set for the container.
virtual void | addWidget (std::unique_ptr< WWidget > widget)
| Adds a child widget to this container.
template<typename Widget >
Widget * | addWidget (std::unique_ptr< Widget > widget)
| Adds a child widget to this container, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | addNew (Args &&...args)
| Creates a widget and adds it, returning a reference to it.
virtual void | insertBefore (std::unique_ptr< WWidget > widget, WWidget *before)
| Inserts a child widget in this container, before another widget.
template<typename Widget >
Widget * | insertBefore (std::unique_ptr< Widget > widget, WWidget *before)
| Inserts a child widget to this container, before another widget, returning a raw pointer.
virtual void | insertWidget (int index, std::unique_ptr< WWidget > widget)
| Inserts a child widget in this container at given index.
template<typename Widget >
Widget * | insertWidget (int index, std::unique_ptr< Widget > widget)
| Inserts a child widget to this container at given index, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | insertNew (int index, Args &&...args)
| Creates a widget and inserts it, returning a reference to it.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget from this container.
virtual void | clear ()
| Removes all widgets.
virtual int | indexOf (WWidget *widget) const
| Returns the index of a widget.
virtual WWidget * | widget (int index) const
| Returns the widget at index
virtual int | count () const
| Returns the number of widgets in this container.
void | setContentAlignment (WFlags< AlignmentFlag > contentAlignment)
| Specifies how child widgets must be aligned within the container.
void | setPadding (const WLength &padding, WFlags< Side > sides=AllSides)
| Sets padding inside the widget.
WLength | padding (Side side) const
| Returns the padding set for the widget.
WFlags< AlignmentFlag > | contentAlignment () const
| Returns the alignment of children.
void | setOverflow (Overflow overflow, WFlags< Orientation > orientation=(Orientation::Horizontal|Orientation::Vertical))
| Sets how overflow of contained children must be handled.
void | setList (bool list, bool ordered=false)
| Renders the container as an HTML list.
bool | isList () const
| Returns if this container is rendered as a List.
bool | isUnorderedList () const
| Returns if this container is rendered as an Unordered List.
bool | isOrderedList () const
| Returns if this container is rendered as an Ordered List.
EventSignal< WScrollEvent > & | scrolled ()
| Event signal emitted when scrolling in the widget.
int | scrollTop () const
| return the number of pixels the container is scrolled horizontally
int | scrollLeft () const
| return the number of pixels the container is scrolled vertically
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
Protected Member Functions inherited from Wt::WContainerWidget
Protected Member Functions inherited from Wt::WInteractWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that allows dropping files for upload.

This widget accepts files that are dropped into it. A signal is triggered whenever one or more files are dropped. The filename, type and size of these files is immediately available through the WFileDropWidget::File interface.

The file upload is done sequentially. All files before the currentIndex() have either finished, failed or have been cancelled.

The widget has the default style-class 'Wt-filedropzone'. The style-class 'Wt-dropzone-hover' is added when files are hovered over the widget.

## Member Function Documentation

## ◆ cancelUpload()

void Wt::WFileDropWidget::cancelUpload | ( | File * | file | ) |

Cancels the upload of a file.

If you cancel a file that is still waiting to be uploaded, it will stay in the uploads() vector, but it will be skipped.

## ◆ currentIndex()

int Wt::WFileDropWidget::currentIndex | ( |  | ) | const

Return the index of the file that is currently being handled.

If nothing is to be done, this will return the size of the vector returned by uploads().

## ◆ dropIndicationEnabled()

bool Wt::WFileDropWidget::dropIndicationEnabled | ( |  | ) | const

Returns if the widget is highlighted for drags anywhere on the page.

See also
  setDropIndicationEnabled()

## ◆ enableAjax()

virtual void Wt::WFileDropWidget::enableAjax | ( |  | ) |
| overrideprotectedvirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WWebWidget.

## ◆ globalDropEnabled()

bool Wt::WFileDropWidget::globalDropEnabled | ( |  | ) | const

Returns if all drops are forwarded to this widget.

See also
  setGlobalDropEnabled

## ◆ newUpload()

Signal< File * > & Wt::WFileDropWidget::newUpload | ( |  | ) |

The signal triggers when the upload of a file is about to begin.

After this signal is triggered, the upload automatically starts. The upload can still fail if the file is too large or if there is a network error.

## ◆ remove()

bool Wt::WFileDropWidget::remove | ( | File * | file | ) |

Removes the file.

This can be used to free resources of files that were already uploaded. A file can only be removed if its index in uploads() is before the current index.

## ◆ setDropIndicationEnabled()

void Wt::WFileDropWidget::setDropIndicationEnabled | ( | bool | enable | ) |

Highlight widget if a file is dragged anywhere on the page.

As soon as a drag enters anywhere on the page the styleclass 'Wt-dropzone-indication' is added to this widget. This can be useful to point the user to the correct place to drop the file. Once the user drags a file over the widget itself, the styleclass 'hover-style' is also added. This can be enabled for multiple dropwidgets if only one of them is visible at the same time.

See also
  setGlobalDropEnabled()

## ◆ setFilters()

void Wt::WFileDropWidget::setFilters | ( | const std::string & | acceptAttributes | ) |

Sets input accept attributes.

The accept attribute may be specified to provide user agents with a hint of what file types will be accepted. Use html input accept attributes as input. This only affects the popup that is shown when users click on the widget. A user can still drop any file type.

## ◆ setGlobalDropEnabled()

void Wt::WFileDropWidget::setGlobalDropEnabled | ( | bool | enable | ) |

Allow dropping the files anywhere on the page.

If enabled, a drop anywhere on the page will be forwarded to this widget.

See also
  setDropIndicationEnabled()

## ◆ setHoverStyleClass()

void Wt::WFileDropWidget::setHoverStyleClass | ( | const std::string & | className | ) |

Set the style class that is applied when a file is hovered over the widget.

Deprecated
  Override the css rule '.Wt-filedropzone.Wt-dropzone-hover' instead.

## ◆ tooLarge()

Signal< File *, ::uint64_t > & Wt::WFileDropWidget::tooLarge | ( |  | ) |

The signal triggers when a file is too large for upload.

This signal is triggered when the widget attempts to upload the file.

The second argument is the size of the file in bytes.

## ◆ uploadFailed()

Signal< File * > & Wt::WFileDropWidget::uploadFailed | ( |  | ) |

The signal triggers when an upload failed.

This signal will trigger when the widget skips over one of the files in the list for an unknown reason (e.g. happens when you drop a folder).

## ◆ uploads()

std::vector< File * > Wt::WFileDropWidget::uploads | ( |  | ) | const

Returns the vector of uploads managed by this widget.

The files in this vector are handled sequentially by the widget. All WFileDropWidget::File objects in this vector have either finished or failed if they are before the currentIndex(), depending on the return value of WFileDropWidget::File::uploadFinished(). The other files are still being handled.

Remarks
  Since version 4.7.0, this method returns a copy of the vector because we changed the internal vector to hold values of type std::unique_ptr.

See also
  currentIndex()